
def propagate_dependencies(vault):
    for var in vault.variables:
        var.group_name = None

    variables = [variable for variable in vault.variables]

    groups = {}

    for var in variables:
        groups_found = []
        for v in var.same_as:
            if v.group_name is not None:
                groups_found.append(v.group_name)
        if not groups_found:
            groups[var_identifier(var)] = [var]
            var.group_name = var_identifier(var)
        else:
            selected_group = groups_found[0]
            var.group_name = selected_group
            groups[selected_group].append(var)
            for group in groups_found:
                if group != selected_group:
                    while len(groups[group]):
                        v = groups[group].pop(0)
                        v.group_name = selected_group
                        groups[selected_group].append(v)
                    # del groups[group]

    for group in groups.values():
        for var in group:
            var.same_as = [v for v in group if v != var]

            
def var_identifier(var):
    return "%s%s%s" %(var.name, var.routine.name,var.routine.module.name)

